<template lang="pug">
    v-app
        link(href="https://fonts.googleapis.com/css?family=Audiowide&display=swap" rel="stylesheet")
        v-app-bar(app clipped-left :color="'#8BC34A'")
            v-app-bar-nav-icon(
                v-if="getLoggedIn"
                @click="draw = !draw"
            )
            v-toolbar-title.main-title DigABase
            v-spacer
            v-btn(
                v-if="getLoggedIn"
                color="brown"
                @click="forceRefresh"
            ) Refresh
                v-icon(
                    right
                ) mdi-refresh
        v-navigation-drawer(
            v-if="getLoggedIn"
            app
            :clipped="true"
            bottom
            v-model="draw"
            dark
            src="@/assets/pixel-soil2.png"
        )
            v-sheet.ma-2(
                tile
                color="white"
            )
                v-list-item
                    v-list-item-content.black--text
                        v-list-item-title.text-center.title
                            | Application
                        v-list-item
                            v-btn(
                                color="secondary"
                                block
                                tile
                                @click="usersNavigate"
                            ) Users
                        v-list-item
                            v-btn(
                                color="secondary"
                                block
                                tile
                            ) Settings
            template(v-slot:append)
                div.ma-2
                    v-btn(
                        color="secondary"
                        block
                        @click="logout"
                    ) Log Out
        v-content
            v-progress-linear(
                :active="(loading.total - loading.loaded)  > 0"
                :value="(loading.loaded / loading.total) * 100"
            )
            v-container.fluid.fill-height
                v-layout.justify-center.align-center
                    v-flex.text-xs-center
                        v-breadcrumbs(
                            v-if="getLoggedIn"
                            :items="breadcrumbs"
                        )
                        router-view
        v-snackbar.text-center(
          v-model="snackbar"
          persistent
        ) {{ notification }}
</template>

<script>
import { mapGetters } from "vuex";
export default {
    name: "App",
    data() {
        return {
            snackbar: false,
            draw: null
        };
    },
    watch: {
        notification() {
            this.snackbar = true;
        }
    },
    computed: {
        ...mapGetters({
            getAProject: "project/getAProject",
            getASite: "site/getASite",
            getATrench: "trench/getATrench",
            notification: "getNotification",
            loading: "loading",
            getLoggedIn: "getLoggedIn"
        }),
        breadcrumbs() {
            let crumbs = [
                {
                    text: "Projects",
                    link: true,
                    to: "/projects",
                    disabled: false,
                    exact: true
                }
            ];
            // TODO: This requires some work to make correct, What if a user walks back up the url and sselects a new project,
            // site and trench will still exist making an invalid link
            if (this.getAProject.data) {
                crumbs.push({
                    text: "Sites",
                    link: true,
                    to: `/project/${this.getAProject.data.id}/site`,
                    disabled: false,
                    exact: true
                });
                if (this.getASite.data) {
                    crumbs.push({
                        text: "Trenches",
                        link: true,
                        to: `/project/${this.getAProject.data.id}/site/${
                            this.getASite.data.id
                        }/trenchs`,
                        disabled: false,
                        exact: true
                    });
                    if (this.getATrench.data) {
                        crumbs.push({
                            text: "Contexts",
                            link: true,
                            to: `/project/${this.getAProject.data.id}/site/${
                                this.getASite.data.id
                            }/trenchs/${this.getATrench.data.id}/contexts`,
                            disabled: false,
                            exact: true
                        });
                    }
                }
            }
            return crumbs;
        }
    },
    methods: {
        logout() {
            this.$store.dispatch("resetAll");
            localStorage.clear();
            this.$router.push({ path: "/" });
        },
        forceRefresh() {
            this.$store.commit("resetLoading");
            this.$store.dispatch("getCurrentURL", {
                projectID: this.getAProject.data
                    ? this.getAProject.data.id
                    : null,
                siteID: this.getASite.data ? this.getASite.data.id : null,
                trenchID: this.getATrench.data ? this.getATrench.data.id : null,
                refresh: true
            });
        },
        usersNavigate() {
            this.$router.push({ path: "/users" });
        }
    }
};
</script>

<style>
.main-title {
    font-size: 2rem !important;
    font-family: "Audiowide", cursive;
}
</style>
